!****m* e0pro/main
! NAME 
!   COMADM
! PURPOSE
!   Administration and housekeeping
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
MODULE COMADM
!---------------------------------------------------------------------
  USE comdim, ONLY : nc     !Get actual array dimensions
  IMPLICIT NONE
  PUBLIC
!---------------------------------------------------------------------  
#ifdef mhd                                                              
!L       H.1       MHD variables at cell centers              
  REAL(8), DIMENSION(nc) :: PTHE, PTHEO, PMAG, PMAGO, TEMP,   &
                            TEMPO, VEL1, VEL1O, VEL2, VEL2O,  &
                            VEL3, VEL3O, VELC                                          
!L       H.2       MHD variables at cell interfaces           
  REAL(8), DIMENSION(nc+1) ::  UH, B1H, B2H, B3H, V1H, V2H,   &
                               V3H, VCH, PTH, PMH 
#else                                                                   
!L       H.1       HD variables at cell centers              
  REAL(8), DIMENSION(nc) ::  PTHE, PTHEO, TEMP, TEMPO, VEL1,  &
                             VEL1O, VEL2, VEL2O, VEL3, VEL3O, &
                             VELC                                                       
!L       H.2       HD variables at cell interfaces           
  REAL(8), DIMENSION(nc+1) ::  V1H, V2H, V3H, PTH, VCH 
#endif
END MODULE COMADM
