!****h* e0pro/main
! NAME 
!   COMBND
! PURPOSE
!   Boundary conditions
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
MODULE COMBND
!---------------------------------------------------------------------  
  USE commax        !Get maximum array dimensions
  USE comdim        !Get actual array dimensions
  IMPLICIT NONE
  PUBLIC
!---------------------------------------------------------------------  
!L       B.1       Boundary conditions-1                      
  LOGICAL :: NLTBC 
!L       B.2       Boundary conditions-2 (X1-X2-X3)           
  REAL(8) :: TIMEBN, TIMEBO, VROT
#ifdef bctim2c
  REAL(8), DIMENSION(nbb1)  :: X1BN,  X1BO, X1P
  REAL(8), DIMENSION(nbb1h) :: X1BNH, X1BOH
#else
  REAL(8) ::  X1BN,  X1BO, X1P
  REAL(8) ::  X1BNH, X1BOH
#endif
  REAL(8), DIMENSION(nbb2)  :: X2BN, X2BO
  REAL(8), DIMENSION(nbb3)  :: X3BN, X3BO
  REAL(8), DIMENSION(nbb2h) :: X2BNH, X2BOH
  REAL(8), DIMENSION(nbb3h) :: X3BNH, X3BOH
  REAL(8), DIMENSION(ncc2)  :: X2FNM, X2FNP, X2FOM, X2FOP, X2P
  REAL(8), DIMENSION(ncc3)  :: X3FNM, X3FNP, X3FOM, X3FOP, X3P
!L       B.3       Boundary conditions-3 (X1-X2-X3)           
  INTEGER :: NBNDIN, NXFROM
  INTEGER, DIMENSION(ncc2) :: NX2FNM, NX2FNP, NX2FOM, NX2FOP
  INTEGER, DIMENSION(ncc3) :: NX3FNM, NX3FNP, NX3FOM, NX3FOP
!L       B.4       Boundary conditions-4 (X1-X2-X3: MHD)      
#ifdef bctim2c
  REAL(8), DIMENSION(nbb1,nbb2,nbb3)  :: &
#else
  REAL(8), DIMENSION(nbb2,nbb3)  :: &
#endif
    B1BN, B2BN, B3BN, BPBN, DBN, DPBN, tbn, v1bn, v2bn, v3bn, &
    uubn, dv1bn, dv2bn, dv3bn
!L       B.5       Boundary conditions-5 (X1-X2-X3: MHD)      
#ifdef bctim2c
  REAL(8), DIMENSION(nbb1,nbb2,nbb3)  :: &
#else
  REAL(8), DIMENSION(nbb2,nbb3)  :: &
#endif
    B1Bo, B2Bo, B3Bo, BPBo, DBo, DPBo, tbo, v1bo, v2bo, v3bo, &
    uubo, dv1bo, dv2bo, dv3bo
!L       B.6       Boundary conditions-6 (X1-X2-X3: MHD)      
#ifdef bctim2c
  REAL(8), DIMENSION(nbb1,nbb2,nbb3)  :: &
#else
  REAL(8), DIMENSION(nbb2,nbb3)  :: &
#endif
    B1PV, B2PV, B3PV, BPPV, DPV, DPPV, UUPV, DV1PV, &
    DV2PV, DV3PV, tpv, v1pv, v2pv, v3pv
END MODULE COMBND
