!****m* e0pro/main
! NAME 
!   COMADM
! PURPOSE
!   Physical conditions
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
MODULE COMPHY
!---------------------------------------------------------------------  
  USE commax        !Get maximum array dimensions
  USE comdim        !Get actual array dimensions
  IMPLICIT NONE
  PUBLIC
!---------------------------------------------------------------------  
!L       P.1       Physical constants                          
  REAL(8), PARAMETER :: CGAS = 8.3143d3,  CGRAV = 6.670d-11,    &
                        CK = 1.38054d-23, CMASS = 1.67239d-27,  &
                        CMU = 1.2566d-6,  CPI=3.1415927d0
!---------------------------------------------------------------------  
!L       P.2       Parameters defining a run                  
  REAL(8) :: VUTIME, VUX1, VUX2, VUX3, DATE, TIME, TSTART, TSTOP,  &
             ZMU, ZRMU, ZR2MU, XMASS, RGAS, GAMMAM,                &
             GAMCLD, XALPHA, GRAV, XMGRAV, GDT, GDTH,              &
             Z05, ZGAMMA, ZGAS, ZGRAV, ZTWOM, QHEAT        
  INTEGER :: NHEAT 
#ifdef gam3d
  REAL(8), DIMENSION :: GAMMA(nc1,nc2,nc3,maxblk)
#else
  REAL(8) :: GAMMA
#endif
#ifdef heat
!   DIMENSION  QHEAT(nc1,nc2,nc3,maxblk)
#endif
!L       P.3       Parameters defining a run                  

  INTEGER :: NBCMAG, NRECON, NSTART, NSTEP, NSTOP, NTEST 
  LOGICAL :: NLXN, NLXP, NLGRAV 
!---------------------------------------------------------------------  
!L       P.4       External heat source                     
  REAL(8) :: YJZINI, YJZMAX, YJZLIM, DIFMAX, ETAMAX, ETALIM,  &
             YJZANO, ETAANO, ETACON                                            
END MODULE COMPHY
