!****m* e0pro/main
! NAME 
!   COMREG
! PURPOSE
!   Computational region
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
MODULE COMREG
!---------------------------------------------------------------------  
  USE commax
  USE comdim
  IMPLICIT NONE
  PUBLIC
!---------------------------------------------------------------------  
!L       R.1       Topographical X123 parameters              
  REAL(8) ::  X1L, X1R, X2L, X2R, X3L, X3R
  REAL(8) ::  XH1, XH2, XH3, XC1, XC2, XC3 
  DIMENSION  XH1(nh1,maxblk), XH2(nh2,maxblk),                       &
             XH3(nh3,maxblk), XC1(nc1,maxblk),                       &
             XC2(nc2,maxblk), XC3(nc3,maxblk)           
  INTEGER :: NC1L, NC1R, NC2L, NC2R, NC3L, NC3R, NC1LM, NC1RP,       &
             NC2LM, NC2RP, NC3LM, NC3RP                                 
#ifdef NGRID
  REAL(8), DIMENSION(maxblk) :: xx1l, xx1r, xx2l, xx2r, xx3l, xx3r
  INTEGER, DIMENSION(maxblk) :: nparent
  INTEGER, DIMENSION(3,maxblk) :: nlevel
  INTEGER, DIMENSION(2,maxblk) :: nbc1l, nbc1r, nbc2l, nbc2r,  &
                                  nbc3l, nbc3r
  INTEGER :: nc1ll, nc1rr, nc2ll, nc2rr, nc3ll, nc3rr
  INTEGER :: nc125, nc175, nc225, nc275, nc325, nc375
#endif
!---------------------------------------------------------------------  
!L       R.2       Topographical X123 parameters              
  REAL(8), DIMENSION(ncc1) :: xcc1
  REAL(8), DIMENSION(ncc2) :: xcc2
  REAL(8), DIMENSION(ncc3) :: xcc3
  REAL(8), DIMENSION(nhh1) :: xhh1
  REAL(8), DIMENSION(nhh2) :: xhh2
  REAL(8), DIMENSION(nhh3) :: xhh3
!---------------------------------------------------------------------  
END MODULE COMREG                             
