!****f* e0pro/main
! NAME 
!   RUNTIM
! PURPOSE
!   Update CPU time (secs) and print it
! HISTORY
!   1981-09-01 DO VUVH Bratislava
!*********************************************************************
SUBROUTINE RUNTIM 
!---------------------------------------------------------------------
  USE comoly
  IMPLICIT NONE
!---------------------------------------------------------------------
#ifdef linux
  REAL(4) :: zsecs
!**** CPU_TIME is a Lahey-Fujitsu Fortran routine giving the date
  call CPU_TIME(zsecs)
  cptime=dble(zsecs)
! if (stime.ne.zero) write(*,*) '   CPU time used so far ',      &
!                               cptime,'secs'
  write(*,*) '   CPU time used so far ', cptime, 'secs'
#endif
!---------------------------------------------------------------------
#ifdef apogee
  REAL(4) :: secnds
!**** SECNDS is an Apogee Fortran routine giving the date
! cptime=dble(secnds(real(stime)))
! if(stime.ne.zero) write(*,*) '   CPU time used so far ',    &
!                              cptime,'secs'
#endif
!---------------------------------------------------------------------
#ifdef hp
  REAL(4) :: secnds
!**** SECNDS is an HP 9000/700 Fortran routine giving the date
!     (requires compilation with +E1 option)
  cptime=dble(secnds(real(stime)))
  if(stime.ne.zero) write (*,*) '   CPU time used so far ',    &
                                cptime, ' secs'
#endif
!---------------------------------------------------------------------
#ifdef ibm
  REAL(8) :: timef
!**** TIMEF is an IBM/SP Fortran routine giving elapsed time (msec)
  cptime=timef()/1000.
  if(myproc.eq.0) then
    write(*,*) '   CPU time used so far ', cptime, 'secs'
  endif
#endif
!---------------------------------------------------------------------
RETURN
END SUBROUTINE RUNTIM


!****f* e0pro/main
! NAME 
!   DAYTIM
! PURPOSE
!   Print date and time
! HISTORY
!   1981-09-01 DO VUVH Bratislava
!*********************************************************************
SUBROUTINE DAYTIM
!---------------------------------------------------------------------
  USE comoly
  IMPLICIT NONE
!---------------------------------------------------------------------
#ifdef linux
  INTEGER, DIMENSION(8) ::  ivalue
  CHARACTER(len=8)  :: idate
  CHARACTER(len=10) :: itime
  CHARACTER(len=5)  :: izone
!**** DATE_AND_TIME is a Lahey-Fujitsu Fortran routine giving the date
  call DATE_AND_TIME(idate,itime,izone,ivalue)
  ldate(1:10) = idate(1:4) //'-'//idate(5:6) //'-'//idate(7:8)
  ltime(1:8) = itime(1:2) //':'//itime(3:4) //':'//itime(5:6)
#endif
!---------------------------------------------------------------------
#ifdef sun
  CHARACTER(len=24) :: ichar
!**** FDATE is a Sun Fortran routine
! call FDATE(ichar)
! ldate(1:10)=ichar(21:24)//'-'//ichar(5:6)//'-'//ichar(9:10)
! ltime(1:8)=ichar(12:19)
#endif
!---------------------------------------------------------------------
#ifdef apogee
  CHARACTER(len=9) :: idate
  CHARACTER(len=8) :: itime
!**** DATE is an Apogee Fortran routine giving the date
  call DATE(idate)
  if(idate(8:8).eq.'9') then
    ldate(1:10)='19'//idate(8:9)//'-'//idate(4:5)//'-'//idate(1:2)
  else
    ldate(1:10)='20'//idate(8:9)//'-'//idate(4:5)//'-'//idate(1:2)
  endif
!**** TIME is an Apogee Fortran routine giving the date
! call TIME(itime)
! ltime(1:8)=itime(1:2)//':'//itime(4:5)//':'//itime(7:8)
#endif
!---------------------------------------------------------------------
#ifdef hp
  CHARACTER(len=9) :: idate
  CHARACTER(len=8) :: itime
!**** DATE is an HP 9000/700 Fortran routine giving the date
!!!!! (requires compilation with +E1 option)
  call DATE(idate)
  if(idate(8:8).eq.'9') then
    ldate(1:10)='19'//idate(8:9)//'-'//idate(4:5)//'-'//idate(1:2)
  else
    ldate(1:10)='20'//idate(8:9)//'-'//idate(4:5)//'-'//idate(1:2)
  endif
!**** TIME is an HP 9000/700 Fortran routine giving the date
!!!!! (requires compilation with +E1 option)
  call TIME(itime)
  ltime=itime
#endif
!---------------------------------------------------------------------
#ifdef cray
  CHARACTER(len=9) :: idate
  CHARACTER(len=8) :: itime
!**** DATE is a CRAY Fortran routine giving the date(mm/dd/yy)
  call DATE(idate)
  ldate(1:10) = '19'//idate(7:8)//'-'//idate(1:2)//'-'//idate(4:5)
!**** CLOCK is a CRAY Fortran routine giving the time (hh:mm:ss)
  call CLOCK(itime)
  ltime=itime
#endif
!---------------------------------------------------------------------
#ifdef ibm
  CHARACTER :: date, clock_
  CHARACTER(len=8) :: idate, itime
!**** DATE is an IBM/SP Fortran routine giving the date(mm/dd/yy)
  idate=DATE()
  ldate=idate
!**** CLOCK_ is an IBM/SP Fortran routine giving the time (hh:mm:ss)
  itime=CLOCK_()
  ltime=itime
#endif
!---------------------------------------------------------------------
  if(myproc.eq.0) then
    write(*,'(a)') '    date = '//ldate//'    time = '//ltime
  endif
!---------------------------------------------------------------------
RETURN
END SUBROUTINE DAYTIM
