!****f* e0pro/main
! NAME 
!   INIEVG
! PURPOSE
!   Find initial mesh positions of the geospace points
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
SUBROUTINE INIEVG
!---------------------------------------------------------------------
  USE comoly
  USE comdim
  USE comphy
  USE comreg
  USE comevo
  USE comout
  IMPLICIT NONE
  INTEGER :: j1, jb, i1geo
#ifdef x3dim
  INTEGER :: j3
#endif
#ifdef x3dim
  INTEGER :: i3geo
#endif
!---------------------------------------------------------------------
#ifdef DIAGNO
  call EXPERT(2003,1)
#endif
!---------------------------------------------------------------------
!L     1.        Positions of geospace points
  if(ngeo.ne.0) then
    do jb=1,nblk
      nxgeo=0
      if(1.496d11.ge.xh1(nc1l,jb)) then
      if(1.496d11.le.xh1(nc1r+1,jb)) then
        nxgeo=5
      endif
      endif
    enddo
  endif
!---------------------------------------------------------------------
!L     2.        Positions of geospace points
  if(nxgeo.gt.0) then
!L       2.1       Radial position
    do jb=1,nblk
      i1geo=nc1l
      do j1=nc1l,nc1r
        if(xh1(j1,jb).le.1.496d11) i1geo=j1
      enddo
      x1geo(1:5)=1.496e11
      n1geo(1:5,jb)=i1geo
!L       2.2       Azimuthal position
#ifdef x3dim
      i3geo=nc3l
      do j3=nc3l,nc3r
        if(xh3(j3,jb).le.cpi) i3geo=j3
      enddo
      x3geo(1)=cpi
      x3geo(2)=xc3(i3geo,jb)
      x3geo(3)=xc3(i3geo+1,jb)
      x3geo(4)=xc3(i3geo,jb)
      x3geo(5)=xc3(i3geo+1,jb)
      n3geo(1,jb)=i3geo
      n3geo(2,jb)=i3geo
      n3geo(3,jb)=i3geo+1
      n3geo(4,jb)=i3geo
      n3geo(5,jb)=i3geo+1
#else
      x3geo(1:5)=cpi
      n3geo(1:5,jb)=1
#endif
    enddo
  endif
!---------------------------------------------------------------------
!L     9.        Return
#ifdef DIAGNO
  call EXPERT(2003,0)
#endif
!---------------------------------------------------------------------
RETURN
END SUBROUTINE INIEVG
