!****f* e0pro/main
! NAME 
!   INIEVH
! PURPOSE
!   Find initial mesh positions of the heliospheric points
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
SUBROUTINE INIEVH
!---------------------------------------------------------------------
  USE comoly
  USE comdim
  USE comphy
  USE comreg
  USE comevo
  USE comout
  IMPLICIT NONE
  INTEGER :: jhel, ihel, j1, jb
#ifdef x2dim
  INTEGER :: j2
#endif
#ifdef x3dim
  INTEGER :: j3
#endif
  INTEGER :: i1hel, i2hel, i3hel
!---------------------------------------------------------------------
#ifdef DIAGNO
  call EXPERT(2003,1)
#endif
!---------------------------------------------------------------------
!L     1.        Positions of heliospheric points
  if(nhel.ne.0) then
    do jb=1,nblk
      nxhel=0
      if(myproc.eq.0) then
        do jhel=1,nhel
          if(x1hel(jhel).ge.xh1(nc1l,jb)) then
          if(x1hel(jhel).le.xh1(nc1r+1,jb)) then
            nxhel=nxhel+1
          endif
          endif
        enddo
      else
        do jhel=1,nhel
          if(x1hel(jhel).gt.xh1(nc1l,jb)) then
          if(x1hel(jhel).le.xh1(nc1r+1,jb)) then
            nxhel=nxhel+1
          endif
          endif
        enddo
      endif
    enddo
  endif
!---------------------------------------------------------------------
!L     2.        Positions of heliospheric points
  if(nxhel.gt.0) then
    do jb=1,nblk
      do jhel=1,nxhel
        ihel=nnhel(myproc+1)+jhel
        i1hel=1
        do j1=nc1l,nc1r
          if(xh1(j1,jb).lt.x1hel(ihel)) i1hel=j1
        enddo
        x1hel(ihel)=xc1(i1hel,jb)
#ifdef x2dim
        i2hel=1
        do j2=nc2l,nc2r
          if(xh2(j2,jb).lt.x2hel(ihel)) i2hel=j2
        enddo
        if(nc2l.eq.nc2r) i2hel=nc2l
        x2hel(ihel)=xc2(i2hel,jb)
#else
        i2hel=1
#endif
#ifdef x3dim
        i3hel=1
        do j3=nc3l,nc3r
          if(xh3(j3,jb).lt.x3hel(ihel)) i3hel=j3
        enddo
        if(nc3l.eq.nc3r) i3hel=nc3l
        x3hel(ihel)=xc3(i3hel,jb)
#else
        i3hel=1
#endif
        n1hel(ihel,jb)=i1hel
        n2hel(ihel,jb)=i2hel
        n3hel(ihel,jb)=i3hel
      enddo
    enddo
  endif
!---------------------------------------------------------------------
!L     9.        Return
#ifdef DIAGNO
  call EXPERT(2003,0)
#endif
!---------------------------------------------------------------------
RETURN
END SUBROUTINE INIEVH
