!****f* e0pro/main
! NAME 
!   INIEVL
! PURPOSE
!   Find initial mesh positions of the Sun-Earth line points
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
SUBROUTINE INIEVL
!---------------------------------------------------------------------
  USE comoly
  USE comdim
  USE comphy
  USE comreg
  USE comevo
  USE comout
  IMPLICIT NONE
  INTEGER :: jsel, isel, j1, jb
#ifdef x3dim
  INTEGER :: j3
#endif
  INTEGER :: i1sel, i3sel
!---------------------------------------------------------------------
#ifdef DIAGNO
  call EXPERT(2003,1)
#endif
!---------------------------------------------------------------------
!L     1.        Positions of Sun-Earth-line points
  if(nsel.ne.0) then
    do jb=1,nblk
      nxsel=0
      if(myproc.eq.0) then
        do jsel=1,nsel
          if(x1sel(jsel).ge.xh1(nc1l,jb)) then
          if(x1sel(jsel).le.xh1(nc1r+1,jb)) then
            nxsel=nxsel+1
          endif
          endif
        enddo
      else
        do jsel=1,nsel
          if(x1sel(jsel).gt.xh1(nc1l,jb)) then
          if(x1sel(jsel).le.xh1(nc1r+1,jb)) then
            nxsel=nxsel+1
          endif
          endif
        enddo
      endif
    enddo
  endif
!---------------------------------------------------------------------
!L     2.        Positions of Sun-Earth-line points
  if(nxsel.gt.0) then
    do jb=1,nblk
#ifdef x3dim
      i3sel=nc3l
      do j3=nc3l,nc3r
        if(xh3(j3,jb).le.cpi) i3sel=j3
      enddo
#else
      i3sel=1
#endif
      do jsel=1,nxsel
        isel=nnsel(myproc+1)+jsel
        i1sel=1
        do j1=nc1l,nc1r
          if(xh1(j1,jb).le.x1sel(isel)) i1sel=j1
        enddo
        n1sel(isel,jb)=i1sel
        n3sel(isel,jb)=i3sel
        x3sel(isel)=cpi
      enddo
    enddo
  endif
!---------------------------------------------------------------------
!L     9.        Return
#ifdef DIAGNO
  call EXPERT(2003,0)
#endif
!---------------------------------------------------------------------
RETURN
END SUBROUTINE INIEVL
