!****f* e0pro/main
! NAME 
!   INISLC
! PURPOSE
!   Find initial mesh positions of the slices
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
SUBROUTINE INISLC
!---------------------------------------------------------------------
  USE comoly
  USE comdim
  USE comphy
  USE comreg
  USE comevo
  USE comout
  IMPLICIT NONE
  INTEGER :: i1geo, jb
#ifdef x3dim
  INTEGER :: i3geo
#endif
!---------------------------------------------------------------------
#ifdef DIAGNO
  call EXPERT(2003,1)
#endif
!---------------------------------------------------------------------
!L     1.        Positions of slices
  if((tsstep.gt.zero).or.(nsstep.gt.0)) then
    do jb=1,nblk
!L       1.1       X1S
      do j1=1,nc1
        if(xh1(j1,jb).le.x1s) nx1s=j1
      enddo
!L       1.2       X2S
      do j2=1,nc2
        if(xh2(j2,jb).le.x2s) nx2s=j2
     enddo
!L       1.3       X3S
      do j3=1,nc3
        if(xh3(j3,jb).le.x3s) nx3s=j3
      enddo
    enddo
  endif
!---------------------------------------------------------------------
!L     9.        Return
#ifdef DIAGNO
  call EXPERT(2003,0)
#endif
!---------------------------------------------------------------------
RETURN
END SUBROUTINE INISLC
