!****f* e0pro/main
! NAME 
!   BND1NG
! PURPOSE
!   Transfer boundary values between blocks
! HISTORY
!   2005-03-12 DO NOAA/SEC
!*********************************************************************
SUBROUTINE BND1NG 
!---------------------------------------------------------------------
  USE comoly 
  USE comdim 
  USE comphy
  USE comreg
  USE comglo
  USE combnd
  USE comadm
  IMPLICIT NONE
#ifdef NGRID
  INTEGER :: ib, jb
#ifdef x2dim
  INTEGER :: i2, j2
#endif
#ifdef x3dim
  INTEGER :: i3, j3
#endif
#endif
#ifdef DIAGNO
  call EXPERT(5007,1)
#endif
#ifdef NGRID
!---------------------------------------------------------------------
!L     1.        X1-Left boundary
  do jb=1,nblk
    ib=nbc1l(1,jb)
    if(ib.gt.0) then
!L       1.1       From equally-spaced grid
      if(nlevel(2,ib).eq.nlevel(2,jb)) then
        unk(:,nc1l-2,:,:,jb)=unk(:,nc1r-1,:,:,ib)
        unk(:,nc1l-1,:,:,jb)=unk(:,nc1r,:,:,ib)
      endif
!L       1.2       From rougher block
      if(nlevel(2,ib).lt.nlevel(2,jb)) then
        if(nbc1l(1,ib).lt.nlevel(1,jb)) then
#ifdef x3dim
#ifdef x2dim
          i3=nc325-1
          do j3=nc3l,nc3r,2
            i3=i3+1
            i2=nc225-1
            do j2=nc2l,nc2r,2
              i2=i2+1
              unk(:,nc1l-2,j2  ,j3  ,jb)=unk(:,nc1r,i2,i3,ib)
              unk(:,nc1l-1,j2  ,j3  ,jb)=unk(:,nc1r,i2,i3,ib)
              unk(:,nc1l-2,j2+1,j3  ,jb)=unk(:,nc1r,i2,i3,ib)
              unk(:,nc1l-1,j2+1,j3  ,jb)=unk(:,nc1r,i2,i3,ib)
              unk(:,nc1l-2,j2  ,j3+1,jb)=unk(:,nc1r,i2,i3,ib)
              unk(:,nc1l-1,j2  ,j3+1,jb)=unk(:,nc1r,i2,i3,ib)
              unk(:,nc1l-2,j2+1,j3+1,jb)=unk(:,nc1r,i2,i3,ib)
              unk(:,nc1l-1,j2+1,j3+1,jb)=unk(:,nc1r,i2,i3,ib)
            enddo
          enddo
#else
          i3=nc325-1
          do j3=nc3l,nc3r,2
            i3=i3+1
            unk(:,nc1l-2,1,j3  ,jb)=unk(:,nc1r,1,i3,ib)
            unk(:,nc1l-1,1,j3  ,jb)=unk(:,nc1r,1,i3,ib)
            unk(:,nc1l-2,1,j3+1,jb)=unk(:,nc1r,1,i3,ib)
            unk(:,nc1l-1,1,j3+1,jb)=unk(:,nc1r,1,i3,ib)
          enddo
#endif
#else
#ifdef x2dim
          i2=nc225-1
          do j2=nc2l,nc2r,2
            i2=i2+1
            unk(:,nc1l-2,j2  ,1,jb)=unk(:,nc1r,i2,1,ib)
            unk(:,nc1l-1,j2  ,1,jb)=unk(:,nc1r,i2,1,ib)
            unk(:,nc1l-2,j2+1,1,jb)=unk(:,nc1r,i2,1,ib)
            unk(:,nc1l-1,j2+1,1,jb)=unk(:,nc1r,i2,1,ib)
          enddo
#else
          unk(:,nc1l-2,1,1,jb)=unk(:,nc1r,1,1,ib)
          unk(:,nc1l-1,1,1,jb)=unk(:,nc1r,1,1,ib)
#endif
#endif
        else
!L       1.3       From rougher interface
#ifdef x3dim
#ifdef x2dim
          i3=nc325-1
          do j3=nc3l,nc3r,2
            i3=i3+1
            i2=nc225-1
            do j2=nc2l,nc2r,2
              i2=i2+1
              unk(:,nc1l-2,j2  ,j3  ,jb)=unk(:,nc1r-1,i2,i3,ib)
              unk(:,nc1l-1,j2  ,j3  ,jb)=unk(:,nc1r  ,i2,i3,ib)
              unk(:,nc1l-2,j2+1,j3  ,jb)=unk(:,nc1r-1,i2,i3,ib)
              unk(:,nc1l-1,j2+1,j3  ,jb)=unk(:,nc1r  ,i2,i3,ib)
              unk(:,nc1l-2,j2  ,j3+1,jb)=unk(:,nc1r-1,i2,i3,ib)
              unk(:,nc1l-1,j2  ,j3+1,jb)=unk(:,nc1r  ,i2,i3,ib)
              unk(:,nc1l-2,j2+1,j3+1,jb)=unk(:,nc1r-1,i2,i3,ib)
              unk(:,nc1l-1,j2+1,j3+1,jb)=unk(:,nc1r  ,i2,i3,ib)
            enddo
          enddo
#else
          i3=nc325-1
          do j3=nc3l,nc3r,2
            i3=i3+1
            unk(:,nc1l-2,1,j3  ,jb)=unk(:,nc1r-1,1,i3,ib)
            unk(:,nc1l-1,1,j3  ,jb)=unk(:,nc1r  ,1,i3,ib)
            unk(:,nc1l-2,1,j3+1,jb)=unk(:,nc1r-1,1,i3,ib)
            unk(:,nc1l-1,1,j3+1,jb)=unk(:,nc1r  ,1,i3,ib)
          enddo
#endif
#else
#ifdef x2dim
          i2=nc225-1
          do j2=nc2l,nc2r,2
            i2=i2+1
            unk(:,nc1l-2,j2  ,1,jb)=unk(:,nc1r-1,i2,1,ib)
            unk(:,nc1l-1,j2  ,1,jb)=unk(:,nc1r  ,i2,1,ib)
            unk(:,nc1l-2,j2+1,1,jb)=unk(:,nc1r-1,i2,1,ib)
            unk(:,nc1l-1,j2+1,1,jb)=unk(:,nc1r  ,i2,1,ib)
          enddo
#else
          unk(:,nc1l-2,1,1,jb)=unk(:,nc1r-1,1,1,ib)
          unk(:,nc1l-1,1,1,jb)=unk(:,nc1r  ,1,1,ib)
#endif
#endif
        endif
      endif
!L       1.4       Continue
    endif
  enddo
!---------------------------------------------------------------------
!L     2.        X1-Right bondary
  do jb=1,nblk
    ib=nbc1r(1,jb)
    if(ib.gt.0) then
!L       2.1       From equally-spaced grid
      if(nlevel(2,ib).eq.nlevel(2,jb)) then
        unk(:,nc1r+1,:,:,jb)=unk(:,nc1l  ,:,:,ib)
        unk(:,nc1r+2,:,:,jb)=unk(:,nc1l+1,:,:,ib)
      endif
!L       2.2       From rougher block
      if(nlevel(2,ib).lt.nlevel(2,jb)) then
        if(nlevel(1,ib).lt.nlevel(1,jb)) then
#ifdef x3dim
#ifdef x2dim
          i3=nc325-1
          do j3=nc3l,nc3r,2
            i3=i3+1
            i2=nc225-1
            do j2=nc2l,nc2r,2
              i2=i2+1
              unk(:,nc1r+1,j2  ,j3  ,jb)=unk(:,nc1l,i2,i3,ib)
              unk(:,nc1r+2,j2  ,j3  ,jb)=unk(:,nc1l,i2,i3,ib)
              unk(:,nc1r+1,j2+1,j3  ,jb)=unk(:,nc1l,i2,i3,ib)
              unk(:,nc1r+2,j2+1,j3  ,jb)=unk(:,nc1l,i2,i3,ib)
              unk(:,nc1r+1,j2  ,j3+1,jb)=unk(:,nc1l,i2,i3,ib)
              unk(:,nc1r+2,j2  ,j3+1,jb)=unk(:,nc1l,i2,i3,ib)
              unk(:,nc1r+1,j2+1,j3+1,jb)=unk(:,nc1l,i2,i3,ib)
              unk(:,nc1r+2,j2+1,j3+1,jb)=unk(:,nc1l,i2,i3,ib)
            enddo
          enddo
#else
          i3=nc325-1
          do j3=nc3l,nc3r,2
            i3=i3+1
            unk(:,nc1r+1,1,j3  ,jb)=unk(:,nc1l,1,i3,ib)
            unk(:,nc1r+2,1,j3  ,jb)=unk(:,nc1l,1,i3,ib)
            unk(:,nc1r+1,1,j3+1,jb)=unk(:,nc1l,1,i3,ib)
            unk(:,nc1r+2,1,j3+1,jb)=unk(:,nc1l,1,i3,ib)
          enddo
#endif
#else
#ifdef x2dim
          i2=nc225-1
          do j2=nc2l,nc2r,2
            i2=i2+1
            unk(:,nc1r+1,j2  ,1,jb)=unk(:,nc1l,i2,1,ib)
            unk(:,nc1r+2,j2  ,1,jb)=unk(:,nc1l,i2,1,ib)
            unk(:,nc1r+1,j2+1,1,jb)=unk(:,nc1l,i2,1,ib)
            unk(:,nc1r+2,j2+1,1,jb)=unk(:,nc1l,i2,1,ib)
          enddo
#else
          unk(:,nc1r+1,1,1,jb)=unk(:,nc1l,1,1,ib)
          unk(:,nc1r+2,1,1,jb)=unk(:,nc1l,1,1,ib)
#endif
#endif
        else
!L       2.3       From rougher interface
#ifdef x3dim
#ifdef x2dim
          i3=nc325-1
          do j3=nc3l,nc3r,2
            i3=i3+1
            i2=nc225-1
            do j2=nc2l,nc2r,2
              i2=i2+1
              unk(:,nc1r+1,j2  ,j3  ,jb)=unk(:,nc1l  ,i2,i3,ib)
              unk(:,nc1r+2,j2  ,j3  ,jb)=unk(:,nc1l+1,i2,i3,ib)
              unk(:,nc1r+1,j2+1,j3  ,jb)=unk(:,nc1l  ,i2,i3,ib)
              unk(:,nc1r+2,j2+1,j3  ,jb)=unk(:,nc1l+1,i2,i3,ib)
              unk(:,nc1r+1,j2  ,j3+1,jb)=unk(:,nc1l  ,i2,i3,ib)
              unk(:,nc1r+2,j2  ,j3+1,jb)=unk(:,nc1l+1,i2,i3,ib)
              unk(:,nc1r+1,j2+1,j3+1,jb)=unk(:,nc1l  ,i2,i3,ib)
              unk(:,nc1r+2,j2+1,j3+1,jb)=unk(:,nc1l+1,i2,i3,ib)
            enddo
          enddo
#else
          i3=nc325-1
          do j3=nc3l,nc3r,2
            i3=i3+1
            unk(:,nc1r+1,1,j3  ,jb)=unk(:,nc1l  ,1,i3,ib)
            unk(:,nc1r+2,1,j3  ,jb)=unk(:,nc1l+1,1,i3,ib)
            unk(:,nc1r+1,1,j3+1,jb)=unk(:,nc1l  ,1,i3,ib)
            unk(:,nc1r+2,1,j3+1,jb)=unk(:,nc1l+1,1,i3,ib)
          enddo
#endif
#else
#ifdef x2dim
          i2=nc225-1
          do j2=nc2l,nc2r,2
            i2=i2+1
            unk(:,nc1r+1,j2  ,1,jb)=unk(:,nc1l  ,i2,1,ib)
            unk(:,nc1r+2,j2  ,1,jb)=unk(:,nc1l+1,i2,1,ib)
            unk(:,nc1r+1,j2+1,1,jb)=unk(:,nc1l  ,i2,1,ib)
            unk(:,nc1r+2,j2+1,1,jb)=unk(:,nc1l+1,i2,1,ib)
          enddo
#else
          unk(:,nc1r+1,1,1,jb)=unk(:,nc1l  ,1,1,ib)
          unk(:,nc1r+2,1,1,jb)=unk(:,nc1l+1,1,1,ib)
#endif
#endif
        endif
      endif
!L       2.4       Continue
    endif
  enddo
!---------------------------------------------------------------------
#endif
!L     9.        Return
#ifdef DIAGNO
  call EXPERT(5007,0)
#endif
RETURN
END SUBROUTINE BND1NG
