!****f* a1d2bc/main
! NAME 
!   MERTIM
! PURPOSE
!   Merging of slab files into a single file
! HISTORY
!   1999-07-31 DO NOAA/SEC Boulder
!*********************************************************************
PROGRAM MERTIM
!=====================================================================
  USE comoly
  USE comdim
  USE comphy
  USE comglo
  USE comreg
  USE commet
  USE comout
  USE netcdf
  IMPLICIT NONE 
!---------------------------------------------------------------------
  CHARACTER :: ldproj*80, ldrun*52
  INTEGER :: idir, iproj, idproj, iini, ibnd, ipas, icase
  INTEGER :: icode, ipar, irun, ires, igrd
  INTEGER :: ifrom, itimes, jslab, jtime
  INTEGER :: ifile_in, ifile
  INTEGER :: ic1, ic2, ic3, ih1, ih2, ih3
!---------------------------------------------------------------------
  INETGER :: i, i0, i00, i000
  INTEGER :: iret, id, ivar
  INTEGER :: jvar, j
  CHARACTER(len=nf90_max_name) :: iname
!---------------------------------------------------------------------
  INTEGER, DIMENSION(2) :: idims1, idims2, idims3,  &
                           idims4, idims5, idims6
  INTEGER< DIMENSION(2) :: istart1, icount1,  &
                           istart4, icount4
  data  idims1/1,7/, idims2/2,7/, idims3/3,7/,  &
        idims4/4,7/, idims5/5,7/, idims6/6,7/ 
  data  istart1/1,1/, icount1/ncc1,maxblk/,  &
        istart4/1,1/, icount4/nhh1,maxblk/
!---------------------------------------------------------------------
  LOGICAL :: ilexis
  INTEGER, DIMENSION(4) :: &
    idims,  istart,  icount
  DATA idims/1,2,3,7/, istart/1,1,1,1/, icount/ncc1,ncc2,ncc3,maxblk/
!---------------------------------------------------------------------
  NAMELIST/NAMJOB/  &
    ALTIME, NSLABS, &
#ifdef PARAMESH
    LREFINE_MIN, LREFINE_MAX, LREFINE_TIM, LREFINE_INI,  &
#endif
    LDIR, LPROJ, LCODE, LBND, LPAS, LINI, LRES, LPAR, LRPAR, LGRD
!---------------------------------------------------------------------
  nblk=maxblk
!---------------------------------------------------------------------
!L     1.        Prologue
  call DAYTIM
!L       1.1       Set characters
  do j=1,120
    lblank(j:j)=' '
  enddo
  lalph='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
  lnum='0123456789'
!L       1.2       Clear labels
  ldir=lblank(1:80)
  lproj=lblank(1:8)
  lcase=lblank(1:30)
  lcode=lblank(1:12)
  lpar=lblank(1:8)
  lrun=lblank(1:52)
  lgrd=lblank(1:12)
  lres=lblank(1:8)
  lini=lblank(1:8)
  lbnd=lblank(1:8)
  lpas=lblank(1:8)
  lfin=lblank(1:120)
  lfout=lblank(1:120)
  ldproj=lblank(1:80)
  ldrun=lblank(1:52)
!---------------------------------------------------------------------
!L     2.        Read in parameters
  read(*,'(A)') LAJOB
  write(*,'(a)') '=== MERTIM: '//lajob
  read(*,NAMJOB)
!---------------------------------------------------------------------
!L     3.        Auxiliary computations
!L       3.1       Length of file names
!Principal directory
  idir=0
  do j=1,52
    if(ldir(j:j).ne.' ') idir=idir+1
  enddo
  if(idir.eq.0) then
    ldir='.'
    idir=1
  endif
!Project name
  iproj=0
  do j=1,8
    if(lproj(j:j).ne.' ') iproj=iproj+1
  enddo
!Code names
  icode=0
  do j=1,12
    if(lcode(j:j).ne.' ') icode=icode+1
  enddo
!Grid name
  igrd=0
  do j=1,12
    if(lgrd(j:j).ne.' ') igrd=igrd+1
  enddo
!Run names
  iini=0
  ires=0
  ibnd=0
  ipas=0
  ipar=0
  do j=1,8
    if(lini(j:j).ne.' ') iini=iini+1
    if(lres(j:j).ne.' ') ires=ires+1
    if(lbnd(j:j).ne.' ') ibnd=ibnd+1
    if(lpas(j:j).ne.' ') ipas=ipas+1
    if(lpar(j:j).ne.' ') ipar=ipar+1
  enddo
!L       3.2       Set the project directory name
  ldproj=ldir(1:idir)//'/'//lproj(1:iproj)
  idproj=idir+1+iproj
!L       3.3       Set the case name
  if((iini.eq.0).and.(ires.eq.0).and.(ibnd.eq.0).and.(ipas.eq.0)) then
  endif
  if((iini.eq.0).and.(ires.eq.0).and.(ibnd.gt.0).and.(ipas.eq.0)) then
    lcase=lbnd(1:ibnd)//'.'//lgrd(1:igrd)
    icase=ibnd+1+igrd
  endif
  if((iini.eq.0).and.(ires.eq.0).and.(ibnd.eq.0).and.(ipas.gt.0)) then
    lcase=lpas(1:ipas)//'.'//lgrd(1:igrd)
    icase=ipas+1+igrd
  endif
  if((iini.gt.0).and.(ires.eq.0).and.(ibnd.eq.0).and.(ipas.eq.0)) then
    lcase=lini(1:iini)//'.'//lgrd(1:igrd)
    icase=iini+1+igrd
  endif
  if((iini.gt.0).and.(ires.eq.0).and.(ibnd.gt.0).and.(ipas.eq.0)) then
    lcase=lini(1:iini)//'.'//lbnd(1:ibnd)//'.'//lgrd(1:igrd)
    icase=iini+1+ibnd+1+igrd
  endif
  if((iini.gt.0).and.(ires.eq.0).and.(ibnd.eq.0).and.(ipas.gt.0)) then
    lcase=lini(1:iini)//'.'//lpas(1:ipas)//'.'//lgrd(1:igrd)
    icase=iini+1+ipas+1+igrd
  endif
  if((iini.eq.0).and.(ires.gt.0).and.(ibnd.eq.0).and.(ipas.eq.0)) then
    lcase=lres(1:ires)//'.'//lgrd(1:igrd)
    icase=ires+1+igrd
  endif
  if((iini.eq.0).and.(ires.gt.0).and.(ibnd.gt.0).and.(ipas.eq.0)) then
    lcase=lres(1:ires)//'.'//lbnd(1:ibnd)//'.'//lgrd(1:igrd)
    icase=ires+1+ibnd+1+igrd
  endif
  if((iini.eq.0).and.(ires.gt.0).and.(ibnd.eq.0).and.(ipas.gt.0)) then
    lcase=lres(1:ires)//'.'//lpas(1:ipas)//'.'//lgrd(1:igrd)
    icase=ires+1+ipas+1+igrd
  endif
!L       3.4       Set the run name
  ldrun='run.'//lcase(1:icase)//'.'//lcode(1:icode)//'.'//lpar(1:ipar)
  irun=4+icase+1+icode+1+ipar
!---------------------------------------------------------------------
!L     4.        Get number of time levels of input files
  itimes=0
  ilexis=.true.
  do while(ilexis.and.(itimes.le.256))
    itimes=itimes+1
    write(*,*) '   Input time levels =',itimes
!L       4.1       Time level number
    i000=itimes/1000
    i00=(itimes-i000*1000)/100
    i0=(itimes-i000*1000-i00*100)/10
    i=itimes-i000*1000-i00*100-i0*10
    i000=i000+1
    i00=i00+1
    i0=i0+1
    i=i+1
    ltim=lnum(i000:i000)//lnum(i00:i00)//lnum(i0:i0)//lnum(i:i)
!L       4.2       Input file name
    lfin=ldproj(1:idproj)//'/'//ldrun(1:irun)//'/'// &
      '0001.tim.'//ltim//'.nc'
!L       4.3       Check existence of the file
    INQUIRE(file=lfin,exist=ilexis)
  enddo
  itimes=itimes-1
!---------------------------------------------------------------------
!L     5.        Get number of time levels of merged files
  ifrom=0
  ilexis=.true.
  do while(ilexis.and.(ifrom.le.256))
    ifrom=ifrom+1
    write(*,*) '   Merged time levels =',ifrom
!L       5.1       Time level number
    i000=ifrom/1000
    i00=(ifrom-i000*1000)/100
    i0=(ifrom-i000*1000-i00*100)/10
    i=ifrom-i000*1000-i00*100-i0*10
    i000=i000+1
    i00=i00+1
    i0=i0+1
    i=i+1
    ltim=lnum(i000:i000)//lnum(i00:i00)//lnum(i0:i0)//lnum(i:i)
!L       5.2       Input file name
    lfin=ldproj(1:idproj)//'/'//ldrun(1:irun)//'/'// &
      'tim.'//ltim//'.nc'
!L       5.3       Check existence of the file
    INQUIRE(file=lfin,exist=ilexis)
  enddo
  ifrom=ifrom-1
  if(ifrom.eq.0) ifrom=1
!---------------------------------------------------------------------
!L     6.        Loop over time levels
  do jtime=ifrom,itimes,1
    write(*,*) '   --- jtime =',jtime
!L       6.1       Time level number
    i000=jtime/1000
    i00=(jtime-i000*1000)/100
    i0=(jtime-i000*1000-i00*100)/10
    i=jtime-i000*1000-i00*100-i0*10
    i000=i000+1
    i00=i00+1
    i0=i0+1
    i=i+1
    ltim=lnum(i000:i000)//lnum(i00:i00)//lnum(i0:i0)//lnum(i:i)
!L       6.2       Output file
    lfout=ldproj(1:idproj)//'/'//ldrun(1:irun)//'/'// &
      'tim.'//ltim//'.nc'
!---------------------------------------------------------------------
!L     7.        Loop over slab
    do jslab=0,nslabs-1
      write(*,*) '       --- jslab=',jslab
!L       7.1       Slab number
      i000=jslab/1000
      i00=(jslab-i000*1000)/100
      i0=(jslab-i000*1000-i00*100)/10
      i=jslab-i000*1000-i00*100-i0*10
      i000=i000+1
      i00=i00+1
      i0=i0+1
      i=i+1
      lproc=lnum(i000:i000)//lnum(i00:i00)//lnum(i0:i0)//lnum(i:i)
!L       7.2       Input file
      lfin=ldproj(1:idproj)//'/'//ldrun(1:irun)//'/'// &
        lproc//'.tim.'//ltim//'.nc'
!---------------------------------------------------------------------
!L     8.        Read in the input data
!L       8.1       Hyperslab positions
      istart1(1)=jslab*ncc1+1
      icount1(1)=ncc1
      istart4(1)=istart1(1)
      icount4(1)=nhh1
      istart(1)=istart1(1)
      icount(1)=icount1(1)
!L       8.2       Open the input file
      iret=NF90_OPEN(lfin,nf90_nowrite,ifile_in)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'name',lrun)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'project',lproj)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'initial',laini)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'resume',lares)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'boundary',labnd)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'passage',lapas)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'grid',lagrd)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'code',lacode)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'parameters',lapar)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'refdate_mjd',refdate)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'gamma',gamma)
      iret=NF90_GET_ATT(ifile_in,NF90_GLOBAL,'xalpha',xalpha)
!L       8.3       Array dimensions
      iret=NF90_INQUIRE_DIMENSION(ifile_in,1,iname,ic1)
      iret=NF90_INQUIRE_DIMENSION(ifile_in,2,iname,ic2)
      iret=NF90_INQUIRE_DIMENSION(ifile_in,3,iname,ic3)
      iret=NF90_INQUIRE_DIMENSION(ifile_in,4,iname,ih1)
      iret=NF90_INQUIRE_DIMENSION(ifile_in,5,iname,ih2)
      iret=NF90_INQUIRE_DIMENSION(ifile_in,6,iname,ih3)
!L       8.4       Numerical mesh
      iret=NF90_GET_VAR(ifile_in,1,z4x1)
      iret=NF90_GET_VAR(ifile_in,2,z4x2)
      iret=NF90_GET_VAR(ifile_in,3,z4x3)
      iret=NF90_GET_VAR(ifile_in,4,z4h1)
      iret=NF90_GET_VAR(ifile_in,5,z4h2)
      iret=NF90_GET_VAR(ifile_in,6,z4h3)
!---------------------------------------------------------------------
!L     9.        Define output file
      if(jslab.eq.0) then
!L       9.1       Create the new file
        iret=NF90_CREATE(lfout,nf90_clobber,ifile)
!L       9.2       Set global attributes
        iret=NF90_PUT_ATT(ifile,nf90_global,'type','TIM')
        iret=NF90_PUT_ATT(ifile,nf90_global,'title', &
          'Values at time levels')
#include <attribut.src>
!L       9.3       Set array dimensions
        ic1=nslabs*ncc1
        iret=NF90_DEF_DIM(ifile,'n1',ic1,id)
        iret=NF90_DEF_DIM(ifile,'n2',ic2,id)
        iret=NF90_DEF_DIM(ifile,'n3',ic3,id)
        ih1=nslabs*ncc1+1
        iret=NF90_DEF_DIM(ifile,'n1h',ih1,id)
        iret=NF90_DEF_DIM(ifile,'n2h',ih2,id)
        iret=NF90_DEF_DIM(ifile,'n3h',ih3,id)
        iret=NF90_DEF_DIM(ifile,'nblk',nblk,id)
!L       9.4       Define mesh structure
        iret=NF90_DEF_VAR(ifile,'X1',nf90_float,idims1,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name', &
          'X1 position of cell centers')
        iret=NF90_DEF_VAR(ifile,'X2',nf90_float,idims2,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name', &
          'X2 position of cell centers')
        iret=NF90_DEF_VAR(ifile,'X3',nf90_float,idims3,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name', &
          'X3 position of cell centers')
        iret=NF90_DEF_VAR(ifile,'X1H',nf90_float,idims4,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name', &
          'X1 position of cell interfaces')
        iret=NF90_DEF_VAR(ifile,'X2H',nf90_float,idims5,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name', &
          'X2 position of cell interfaces')
        iret=NF90_DEF_VAR(ifile,'X3H',nf90_float,idims6,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name', &
          'X3 position of cell interfaces')
!L       9.5       Time
        iret=NF90_DEF_VAR(ifile,'TIME',nf90_float,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name','Physical time')
        iret=NF90_DEF_VAR(ifile,'DT',nf90_float,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name','Physical time step')
        iret=NF90_DEF_VAR(ifile,'NSTEP',nf90_int,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name','Numerical step')
!L       9.6       Magnetohydrodynamic variables
        iret=NF90_DEF_VAR(ifile,'D',nf90_float,idims,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name','Density')
        iret=NF90_DEF_VAR(ifile,'T',nf90_float,idims,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name','Temperature')
        iret=NF90_DEF_VAR(ifile,'V1',nf90_float,idims,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name','X1-velocity')
        iret=NF90_DEF_VAR(ifile,'V2',nf90_float,idims,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name','X2-velocity')
        iret=NF90_DEF_VAR(ifile,'V3',nf90_float,idims,id)
        iret=NF90_PUT_ATT(ifile,id,'long_name','X3-velocity')
#ifdef mhd
          iret=NF90_DEF_VAR(ifile,'B1',nf90_float,idims,id)
          iret=NF90_PUT_ATT(ifile,id,'long_name','X1-magnetic field')
          iret=NF90_DEF_VAR(ifile,'B2',nf90_float,idims,id)
          iret=NF90_PUT_ATT(ifile,id,'long_name','X2-magnetic field')
          iret=NF90_DEF_VAR(ifile,'B3',nf90_float,idims,id)
          iret=NF90_PUT_ATT(ifile,id,'long_name','X3-magnetic field')
#endif
#ifdef hydcon
          iret=NF90_DEF_VAR(ifile,'DP',nf90_float,idims,id)
          iret=NF90_PUT_ATT(ifile,id,'long_name','Density of plasma cloud')
#endif
#ifdef mhdcon
          iret=NF90_DEF_VAR(ifile,'BP',nf90_float,idims,id)
          iret=NF90_PUT_ATT(ifile,id,'long_name','Polarity of magnetic field')
#endif
!L       9.7       Leave define mode
        iret=NF90_ENDDEF(ifile)
!L       9.8       Close the output file
        iret=NF90_CLOSE(ifile)
      endif
!---------------------------------------------------------------------
!L     10.       Output data
!L       10.1      Open the output file
      iret=NF90_OPEN(lfout,nf90_write,ifile)
!L       10.2      Numerical mesh
      iret=NF90_PUT_VAR(ifile,1,z4x1,start=istart1,count=icount1)
      if(jslab.eq.0) then
        iret=NF90_PUT_VAR(ifile,2,z4x2)
        iret=NF90_PUT_VAR(ifile,3,z4x3)
      endif
      iret=NF90_PUT_VAR(ifile,4,z4h1,start=istart4,count=icount4)
      if(jslab.eq.0) then
        iret=NF90_PUT_VAR(ifile,5,z4h2)
        iret=NF90_PUT_VAR(ifile,6,z4h3)
        iret=NF90_GET_VAR(ifile_in,7,z4var)
        iret=NF90_PUT_VAR(ifile,7,z4var)
        iret=NF90_GET_VAR(ifile_in,8,z4var)
        iret=NF90_PUT_VAR(ifile,8,z4var)
        iret=NF90_GET_VAR(ifile_in,9,ivar)
        iret=NF90_PUT_VAR(ifile,9,ivar)
      endif
!L       10.3      Magnetohydrodynamic variables
      do jvar=1,nnvar
        iret=NF90_GET_VAR(ifile_in,9+jvar,z4x123)
        iret=NF90_PUT_VAR(ifile,9+jvar,z4x123,start=istart,count=icount)
      enddo
!L       10.4      Close the output file
      iret=NF90_CLOSE(ifile)
!L       10.5      Close the input file
      iret=NF90_CLOSE(ifile_in)
    enddo
  enddo
!---------------------------------------------------------------------
!L     11.       Stop
  write(*,'(a)') '=== END OF MERTIM'
STOP
END PROGRAM MERTIM


!****f* olympus/daytim
! NAME 
!   DAYTIM
! PURPOSE
!   Print date and time
! HISTORY
!   1981-09-01 DO VUVH Bratislava
!*********************************************************************
SUBROUTINE DAYTIM
!---------------------------------------------------------------------
  USE comoly
  IMPLICIT NONE
!---------------------------------------------------------------------
#ifdef linux
    INTEGER, DIMENSION(8) ::  ivalue
    CHARACTER (len=8)  :: idate
    CHARACTER (len=10) :: itime
    CHARACTER (len=5)  :: izone
!**** DATE_AND_TIME is a Lahey-Fujitsu Fortran routine giving the date
    call DATE_AND_TIME(idate,itime,izone,ivalue)
    ldate(1:10) = idate(1:4) //'-'//idate(5:6) //'-'//idate(7:8)
    ltime(1:8) = itime(1:2) //':'//itime(3:4) //':'//itime(5:6)
#endif
!---------------------------------------------------------------------
#ifdef sun
    CHARACTER(len=24) :: ichar
!**** FDATE is a Sun Fortran routine
!   call FDATE(ichar)
!   ldate(1:10)=ichar(21:24)//'-'//ichar(5:6)//'-'//ichar(9:10)
!   ltime(1:8)=ichar(12:19)
#endif
!---------------------------------------------------------------------
#ifdef apogee
    CHARACTER(len=9) :: idate
    CHARACTER(len=8) :: itime
!**** DATE is an Apogee Fortran routine giving the date
    call DATE(idate)
    if(idate(8:8).eq.'9') then
      ldate(1:10)='19'//idate(8:9) //'-'//idate(4:5) //'-'//    &
        idate(1:2)
    else
      ldate(1:10)='20'//idate(8:9) //'-'//idate(4:5) //'-'//    &
        idate(1:2)
    endif
!**** TIME is an Apogee Fortran routine giving the date
!   call TIME(itime)
!   ltime(1:8)=itime(1:2)//':'//itime(4:5)//':'//itime(7:8)
#endif
!---------------------------------------------------------------------
#ifdef hp
    CHARACTER (len=9) :: idate
    CHARACTER (len=8) :: itime
!**** DATE is an HP 9000/700 Fortran routine giving the date
!!!!! (requires compilation with +E1 option)
    call DATE(idate)
    if(idate(8:8).eq.'9') then
      ldate(1:10)='19'//idate(8:9)//'-'//idate(4:5)//'-'//idate(1:2)
    else
      ldate(1:10)='20'//idate(8:9)//'-'//idate(4:5)//'-'//idate(1:2)
    endif
!**** TIME is an HP 9000/700 Fortran routine giving the date
!!!!! (requires compilation with +E1 option)
    call TIME(itime)
    ltime=itime
#endif
!---------------------------------------------------------------------
#ifdef cray
    CHARACTER (len=9) :: idate
    CHARACTER (len=8) :: itime
!**** DATE is a CRAY Fortran routine giving the date(mm/dd/yy)
    call DATE(idate)
    ldate(1:10) = '19'//idate(7:8)//'-'//idate(1:2)//'-'//idate(4:5)
!**** CLOCK is a CRAY Fortran routine giving the time (hh:mm:ss)
    call CLOCK(itime) 
    ltime=itime 
#endif                              
!---------------------------------------------------------------------  
#ifdef ibm                                                              
    CHARACTER :: date, clock_ 
    CHARACTER(len=8) :: idate, itime 
!**** DATE is an IBM/SP Fortran routine giving the date(mm/dd/yy)      
    idate=DATE() 
    ldate=idate 
!**** CLOCK_ is an IBM/SP Fortran routine giving the time (hh:mm:ss)    
    itime=CLOCK_() 
    ltime=itime 
#endif                              
!---------------------------------------------------------------------  
  if(myproc.eq.0) then 
    write(*,'(a)') '    date = '//ldate//'    time = '//ltime 
  endif 
!---------------------------------------------------------------------  
RETURN 
END SUBROUTINE DAYTIM                         
